package org.jeecg.modules.ctop.job;

import cn.com.ctop.common.module.utils.HttpUtils;
import cn.com.ctop.crawler.modules.dataeye.entity.DataeyeCompany;
import cn.com.ctop.crawler.modules.dataeye.entity.DataeyeProduct;
import cn.com.ctop.crawler.modules.dataeye.service.DataeyeCompanyService;
import cn.com.ctop.crawler.modules.dataeye.service.DataeyeMediaService;
import cn.com.ctop.crawler.modules.dataeye.service.DataeyeProductService;
import cn.com.ctop.crawler.modules.dataeye.service.impl.DataeyeProductServiceImpl;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Iterator;
import java.util.List;

@Slf4j
public class DataeyeJob implements Job {
    @Autowired
    private DataeyeCompanyService dataeyeCompanyService;
    @Autowired
    private DataeyeProductService dataeyeProductService;
    @Autowired
    private DataeyeMediaService dataeyeMediaService;
    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        dataeyeMediaService.getMediaList();
//        List<DataeyeCompany> list = dataeyeCompanyService.list();
//        if (list != null && list.size() > 0){
//            for(DataeyeCompany dataeyeCompany : list){
//                try {
//                    String result = HttpUtils.httpPostFormRequest("https://blzs.dataeye.com/company/listProductDistribution?companyId="+dataeyeCompany.getCompanyId(),null,null);
//                    ObjectMapper mapper = new ObjectMapper();
//                    mapper.disable(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES);
//                    JsonNode rootNode = mapper.readTree(result);
//                    int statusCode = rootNode.get("statusCode").asInt();
//                    if (statusCode == 200) {
//                        Iterator<JsonNode> nodes = rootNode.get("content").elements();
//                        while (nodes.hasNext()){
//                            JsonNode node = nodes.next();
//                            Long productId = node.get("id").asLong();
//                            dataeyeProductService.getProductInfo(dataeyeCompany.getCompanyId(),productId);
//                        }
//                    }
//                }catch (Exception e){
//                    e.printStackTrace();
//                }
//            }
//        }
//        int pageId=1;
//        while(pageId <= 100){
//            try {
//                System.out.println("pageId:"+pageId);
//                String result = HttpUtils.httpPostFormRequest("https://blzs.dataeye.com/ranking/listCompanyRanking?type=all&pageId="+pageId+"&pageSize=10&mediaId&playRuleId&themeId&searchKey&days=90&top=500",null,null);
//                ObjectMapper mapper = new ObjectMapper();
//                mapper.disable(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES);
//                JsonNode rootNode = mapper.readTree(result);
//                int statusCode = rootNode.get("statusCode").asInt();
//                if (statusCode == 200){
//                    Iterator<JsonNode> nodes = rootNode.get("content").elements();
//                    while (nodes.hasNext()){
//                        JsonNode node = nodes.next();
//                        int companyId = node.get("companyId").asInt();
//                        System.out.println(companyId);
//                        dataeyeCompanyService.getCompanyInfo(companyId);
//                    }
//
//                }
//            }catch (Exception e){
//
//            }
//            pageId++;
//        }
//        for (int i = 3528; i < 1000000; i++){
//            try {
//                dataeyeProductService.getProductInfo(i);
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//        }
    }
}
